## spectrwm 3.4.1

=== Makefile ===
.include <bsd.xconf.mk>

PREFIX?=/usr/local

BINDIR=${PREFIX}/bin
SUBDIR= lib

PROG=spectrwm
MAN=spectrwm.1

CFLAGS+=-std=c99 -Wmissing-prototypes -Wall -Wextra -Wshadow -Wno-uninitialized -g
# Uncomment define below to disallow user settable clock format string
#CFLAGS+=-DSWM_DENY_CLOCK_FORMAT
CPPFLAGS+= -I${X11BASE}/include -I${X11BASE}/include/freetype2
LDADD+=-lutil -L${X11BASE}/lib -lX11 -lX11-xcb -lxcb -lxcb-util -lxcb-icccm -lxcb-keysyms -lxcb-randr -lxcb-xinput -lxcb-xtest -lXft -lXcursor
BUILDVERSION != sh "${.CURDIR}/buildver.sh"
.if !${BUILDVERSION} == ""
CPPFLAGS+= -DSPECTRWM_BUILDSTR=\"$(BUILDVERSION)\"
.endif

MANDIR= ${PREFIX}/man/man

obj: _xenocara_obj

beforeinstall:
	ln -sf ${PROG} ${BINDIR}/scrotwm

spectrwm.html: spectrwm.1
	mandoc -Thtml ${.CURDIR}/spectrwm.1 > spectrwm.html

.include <bsd.prog.mk>
.include <bsd.xorg.mk>

=== freebsd/Makefile ===
.sinclude <bsd.port.pre.mk>

PREFIX?= /usr/local
LOCALBASE?= /usr/local

SWM_BINDIR?= $(PREFIX)/bin
SWM_LIBDIR?= $(PREFIX)/lib
SWM_MANDIR?= $(PREFIX)/man

CC?= cc

LVERS!=	awk -F = '/major/ { printf( "%s.", $$2 ) } /minor/ { printf( "%s", $$2 ) }' ${.CURDIR}/../lib/shlib_version
BUILDVERSION!= sh "${.CURDIR}/../buildver.sh"
.if !${BUILDVERSION} == ""
CFLAGS+= -DSPECTRWM_BUILDSTR=\"$(BUILDVERSION)\"
.endif

CFLAGS+= -std=c99 -Wmissing-prototypes -Wall -Wextra -Wshadow -Wno-uninitialized -g
CFLAGS+= -I. -I${LOCALBASE}/include -I${LOCALBASE}/include/freetype2
CFLAGS+= -DSWM_LIB=\"$(SWM_LIBDIR)/libswmhack.so.$(LVERS)\"
LDADD+= -lutil -L${LOCALBASE}/lib -lX11 -lX11-xcb -lxcb \
	-lxcb-icccm -lxcb-keysyms -lxcb-randr -lxcb-util -lxcb-xinput -lxcb-xtest -lXft -lXcursor


all: spectrwm libswmhack.so.$(LVERS)

spectrwm.c:
	ln -sf ../spectrwm.c
	ln -sf ../version.h
	ln -sf ../linux/pledge.h

swm_hack.c:
	ln -sf ../lib/swm_hack.c

spectrwm: spectrwm.o
	$(CC) $(LDFLAGS) $(LDADD) -o ${.TARGET} ${.ALLSRC}

swm_hack.so: swm_hack.c
	$(CC) $(CFLAGS) -c -shared -fpic -DPIC -o ${.TARGET} ${.ALLSRC}

libswmhack.so.$(LVERS): swm_hack.so
	$(CC) $(LDFLAGS) -shared -fpic -o ${.TARGET} ${.ALLSRC}

install: all
	install -m 755 -d $(SWM_BINDIR)
	install -m 755 -d $(SWM_LIBDIR)
	install -m 755 -d $(SWM_MANDIR)/man1
	install -m 755 spectrwm $(SWM_BINDIR)
	install -m 755 libswmhack.so.$(LVERS) $(SWM_LIBDIR)
	install -m 644 ../spectrwm.1 $(SWM_MANDIR)/man1/spectrwm.1
	ln -sf spectrwm $(SWM_BINDIR)/scrotwm

clean:
	rm -f spectrwm *.o *.so libswmhack.so.* spectrwm.c swm_hack.c version.h pledge.h

.PHONY:	all install clean

.sinclude <bsd.port.post.mk>

=== lib/Makefile ===
.include <bsd.xconf.mk>

PREFIX?=/usr/local

LIB=    swmhack
NOMAN=	yes
SRCS=	swm_hack.c
LIBDIR= ${X11BASE}/lib

CC?= cc

DEBUGLIBS= no
NOPROFILE= yes

CFLAGS+= -std=c99 -Wmissing-prototypes -Wall -Wextra -Wshadow -Wno-uninitialized -g
CFLAGS+= -fPIC
CFLAGS+= -I${X11BASE}/include
LDADD+= -L${X11BASE}/lib -lX11

install:
	${INSTALL} ${INSTALL_COPY} -o ${LIBOWN} -g ${LIBGRP} -m ${LIBMODE} \
		lib${LIB}.so.${SHLIB_MAJOR}.${SHLIB_MINOR} \
		${PREFIX}/lib/

.include <bsd.lib.mk>
.include <bsd.xorg.mk>

=== linux/Makefile ===
PREFIX       ?= /usr/local
BINDIR       ?= $(PREFIX)/bin
LIBDIR       ?= $(PREFIX)/lib
SYSCONFDIR   ?= $(PREFIX)/etc
DATAROOTDIR  ?= $(PREFIX)/share
MANDIR       ?= $(DATAROOTDIR)/man
DOCDIR       ?= $(DATAROOTDIR)/doc/spectrwm
XSESSIONSDIR ?= $(DATAROOTDIR)/xsessions
PKG_CONFIG   ?= pkg-config

BUILDVERSION    = $(shell sh $(CURDIR)/../buildver.sh)
LIBVERSION      = $(shell .  $(CURDIR)/../lib/shlib_version; echo $$major.$$minor)
LIBMAJORVERSION = $(shell .  $(CURDIR)/../lib/shlib_version; echo $$major)

MAINT_CFLAGS   = -std=c99 -Wmissing-prototypes -Wall -Wextra -Wshadow -Wno-uninitialized -g
MAINT_LDFLAGS  = -Wl,--as-needed
MAINT_CPPFLAGS = -I. -D_GNU_SOURCE -DSWM_LIB=\"$(LIBDIR)/libswmhack.so.$(LIBVERSION)\"

ifneq ("${BUILDVERSION}", "")
MAINT_CPPFLAGS += -DSPECTRWM_BUILDSTR=\"$(BUILDVERSION)\"
endif

BIN_CFLAGS   = -fPIE
BIN_LDFLAGS  = -fPIE -pie
BIN_CPPFLAGS = $(shell $(PKG_CONFIG) --cflags x11 x11-xcb xcb-icccm xcb-keysyms xcb-randr xcb-util xcb-xinput xcb-xtest xcursor xft)
BIN_LDLIBS   = $(shell $(PKG_CONFIG) --libs   x11 x11-xcb xcb-icccm xcb-keysyms xcb-randr xcb-util xcb-xinput xcb-xtest xcursor xft)
LIB_CFLAGS   = -fPIC
LIB_LDFLAGS  = -fPIC -shared
LIB_CPPFLAGS = $(shell $(PKG_CONFIG) --cflags x11)
LIB_LDLIBS   = $(shell $(PKG_CONFIG) --libs   x11) -ldl

all: spectrwm libswmhack.so.$(LIBVERSION)

spectrwm: spectrwm.o linux.o
	$(CC) $(MAINT_LDFLAGS) $(BIN_LDFLAGS) $(LDFLAGS) -o $@ $+ $(BIN_LDLIBS) $(LDLIBS)

spectrwm.o: ../spectrwm.c ../version.h tree.h util.h
	$(CC) $(MAINT_CFLAGS) $(BIN_CFLAGS) $(CFLAGS) $(MAINT_CPPFLAGS) $(BIN_CPPFLAGS) $(CPPFLAGS) -c -o $@ $<

linux.o: linux.c util.h
	$(CC) $(MAINT_CFLAGS) $(BIN_CFLAGS) $(CFLAGS) $(MAINT_CPPFLAGS) $(BIN_CPPFLAGS) $(CPPFLAGS) -c -o $@ $<

libswmhack.so.$(LIBVERSION): swm_hack.so
	$(CC) $(MAINT_LDFLAGS) $(LIB_LDFLAGS) $(LDFLAGS) -Wl,-soname,$@ -o $@ $+ $(LIB_LDLIBS) $(LDLIBS)

swm_hack.so: ../lib/swm_hack.c
	$(CC) $(MAINT_CFLAGS) $(LIB_CFLAGS) $(CFLAGS) $(MAINT_CPPFLAGS) $(LIB_CPPFLAGS) $(CPPFLAGS) -c -o $@ $<

clean:
	rm -f spectrwm *.o libswmhack.so.* *.so

install: all
	install -m 755 -d $(DESTDIR)$(BINDIR)
	install -m 755 -d $(DESTDIR)$(LIBDIR)
	install -m 755 -d $(DESTDIR)$(SYSCONFDIR)
	install -m 755 -d $(DESTDIR)$(MANDIR)/man1
	install -m 755 -d $(DESTDIR)$(DOCDIR)
	install -m 755 -d $(DESTDIR)$(DOCDIR)/examples
	install -m 755 -d $(DESTDIR)$(XSESSIONSDIR)
	install -m 755 spectrwm                    $(DESTDIR)$(BINDIR)
	ln -sf spectrwm                            $(DESTDIR)$(BINDIR)/scrotwm
	install -m 755 libswmhack.so.$(LIBVERSION) $(DESTDIR)$(LIBDIR)
	ln -sf libswmhack.so.$(LIBVERSION)         $(DESTDIR)$(LIBDIR)/libswmhack.so.$(LIBMAJORVERSION)
	ln -sf libswmhack.so.$(LIBVERSION)         $(DESTDIR)$(LIBDIR)/libswmhack.so
	install -m 644 ../spectrwm.conf            $(DESTDIR)$(SYSCONFDIR)
	install -m 644 ../spectrwm.1               $(DESTDIR)$(MANDIR)/man1
	install -m 644 ../CHANGELOG.md             $(DESTDIR)$(DOCDIR)
	install -m 644 ../LICENSE.md               $(DESTDIR)$(DOCDIR)
	install -m 644 baraction.sh                $(DESTDIR)$(DOCDIR)/examples
	install -m 644 ../initscreen.sh            $(DESTDIR)$(DOCDIR)/examples
	install -m 644 ../screenshot.sh            $(DESTDIR)$(DOCDIR)/examples
	install -m 644 ../spectrwm_*.conf          $(DESTDIR)$(DOCDIR)/examples
	install -m 644 spectrwm.desktop            $(DESTDIR)$(XSESSIONSDIR)

uninstall:
	rm -f $(DESTDIR)$(BINDIR)/spectrwm
	rm -f $(DESTDIR)$(BINDIR)/scrotwm
	rm -f $(DESTDIR)$(LIBDIR)/libswmhack.so.$(LIBVERSION)
	rm -f $(DESTDIR)$(LIBDIR)/libswmhack.so.$(LIBMAJORVERSION)
	rm -f $(DESTDIR)$(LIBDIR)/libswmhack.so
	rm -f $(DESTDIR)$(SYSCONFDIR)/spectrwm.conf
	rm -f $(DESTDIR)$(MANDIR)/man1/spectrwm.1
	rm -f $(DESTDIR)$(DOCDIR)/CHANGELOG.md
	rm -f $(DESTDIR)$(DOCDIR)/LICENSE.md
	rm -f $(DESTDIR)$(DOCDIR)/examples/baraction.sh
	rm -f $(DESTDIR)$(DOCDIR)/examples/initscreen.sh
	rm -f $(DESTDIR)$(DOCDIR)/examples/screenshot.sh
	rm -f $(DESTDIR)$(DOCDIR)/examples/spectrwm_*.conf
	rm -f $(DESTDIR)$(XSESSIONSDIR)/spectrwm.desktop

.PHONY: all clean install uninstall

=== netbsd/Makefile ===
.sinclude <bsd.pkg.pre.mk>

PREFIX?= /usr/pkg
LOCALBASE?= /usr/pkg

SWM_BINDIR?= ${DESTDIR}$(PREFIX)/bin
SWM_LIBDIR?= ${DESTDIR}$(PREFIX)/lib
SWM_MANDIR?= ${DESTDIR}$(PREFIX)/${PKGMANDIR}

LVERS!=	awk -F = '/major/ { printf( "%s.", $$2 ) } /minor/ { printf( "%s", $$2 ) }' ${.CURDIR}/../lib/shlib_version
BUILDVERSION!= sh "${.CURDIR}/../buildver.sh"
.if !${BUILDVERSION} == ""
CFLAGS+= -DSPECTRWM_BUILDSTR=\"$(BUILDVERSION)\"
.endif

CFLAGS+= -std=c99 -Wmissing-prototypes -Wall -Wextra -Wshadow -Wno-uninitialized -g
CFLAGS+= -I. -I${LOCALBASE}/include -I${LOCALBASE}/include/freetype2
CFLAGS+= -DSWM_LIB=\"$(SWM_LIBDIR)/libswmhack.so.$(LVERS)\"
LDADD+= -lutil -L${LOCALBASE}/lib -lX11 -lX11-xcb -lxcb \
	-lxcb-icccm -lxcb-keysyms -lxcb-randr -lxcb-util -lxcb-xinput -lxcb-xtest -lXft -lXcursor


all: spectrwm libswmhack.so.$(LVERS)

spectrwm.c:
	ln -sf ../spectrwm.c
	ln -sf ../version.h
	ln -sf ../linux/pledge.h

swm_hack.c:
	ln -sf ../lib/swm_hack.c

spectrwm: spectrwm.o
	$(CC) $(LDFLAGS) $(LDADD) -o ${.TARGET} ${.ALLSRC}

swm_hack.so: swm_hack.c
	$(CC) $(CFLAGS) -c -shared -fpic -DPIC -o ${.TARGET} ${.ALLSRC}

libswmhack.so.$(LVERS): swm_hack.so
	$(CC) $(LDFLAGS) -shared -fpic -o ${.TARGET} ${.ALLSRC}

install: all
	$(BSD_INSTALL_PROGRAM_DIR) $(SWM_BINDIR)
	$(BSD_INSTALL_LIB_DIR) $(SWM_LIBDIR)
	$(BSD_INSTALL_MAN_DIR) $(SWM_MANDIR)/man1
	$(BSD_INSTALL_PROGRAM) spectrwm $(SWM_BINDIR)
	$(BSD_INSTALL_LIB) libswmhack.so.$(LVERS) $(SWM_LIBDIR)
	$(BSD_INSTALL_MAN) ../spectrwm.1 $(SWM_MANDIR)/man1/spectrwm.1
	ln -sf spectrwm $(SWM_BINDIR)/scrotwm

clean:
	rm -f spectrwm *.o *.so libswmhack.so.* spectrwm.c swm_hack.c version.h

.PHONY:	all install clean

.sinclude <bsd.pkg.post.mk>

=== osx/Makefile ===
PREFIX?= /usr/local
BINDIR?= $(PREFIX)/bin
LIBDIR?= $(PREFIX)/lib
MANDIR?= $(PREFIX)/share/man

BUILDVERSION    = $(shell sh $(CURDIR)/../buildver.sh)

# To use xquartz, uncomment the following three lines.
INCFLAGS+= -I/opt/X11/include -I/opt/X11/include/freetype2/
LDADD+=  -L/opt/X11/lib -lX11 -lXcursor -lXft

# To use homebrew, uncomment the following three lines.
#INCFLAGS+= -I/opt/X11/include
#LDADD+=  -lX11 -lXcursor -lXft -L/opt/X11/lib
#INCFLAGS+= -I/usr/local/Cellar/freetype/2.5.0.1/include/freetype2

# To use homebrew , comment out the following two lines.
#INCFLAGS+= -I/opt/local/include/freetype2 -I/opt/local/include
#LDADD+=  -L/opt/local/lib -lX11 -lXcursor -lXft

LDADD+=  -lxcb-keysyms -lxcb-util -lxcb-randr -lX11-xcb -lxcb-xtest -lxcb -lxcb-icccm

LVERS= $(shell . ../lib/shlib_version; echo $$major.$$minor)

CFLAGS+= -std=c99 -Wmissing-prototypes -Wall -Wextra -Wshadow -Wno-uninitialized -g
CFLAGS+= -O2 -D_GNU_SOURCE -D__OSX__ -I. -I.. ${INCFLAGS}
CFLAGS+= -DSWM_LIB=\"$(LIBDIR)/libswmhack.so.$(LVERS)\"
ifneq ("${BUILDVERSION}", "")
CFLAGS+= -DSPECTRWM_BUILDSTR=\"$(BUILDVERSION)\"
endif

CC?= cc

all: spectrwm libswmhack.so.$(LVERS)

spectrwm.c:
	ln -sf ../linux/tree.h
	ln -sf ../spectrwm.c
	ln -sf ../version.h
	ln -sf ../linux/pledge.h

swm_hack.c:
	ln -sf ../lib/swm_hack.c

spectrwm: spectrwm.o osx.o
	$(CC) $(LDFLAGS) -o $@ $+ $(LDADD)

%.so: %.c
	$(CC) $(CFLAGS) -c -fpic -DPIC $+ -o $@

libswmhack.so.$(LVERS): swm_hack.so
	$(CC) $(LDFLAGS) -shared -fpic -o libswmhack.so.$(LVERS) swm_hack.so $(LDADD)
# replace above line with this for OSX 10.5
#	$(CC) -shared -bundle -fpic -o libswmhack.so.$(LVERS) $(LDADD) swm_hack.so

install: all
	install -m 755 -d $(DESTDIR)$(BINDIR)
	install -m 755 -d $(DESTDIR)$(LIBDIR)
	install -m 755 -d $(DESTDIR)$(MANDIR)/man1
	install -m 755 spectrwm $(DESTDIR)$(BINDIR)
	install -m 755 libswmhack.so.$(LVERS) $(DESTDIR)$(LIBDIR)
	install -m 644 ../spectrwm.1 $(DESTDIR)$(MANDIR)/man1/spectrwm.1
	ln -sf spectrwm $(DESTDIR)$(BINDIR)/scrotwm
	ln -sf libswmhack.so.0.0 $(DESTDIR)$(LIBDIR)/libswmhack.so.0
	ln -sf libswmhack.so.0.0 $(DESTDIR)$(LIBDIR)/libswmhack.so

clean:
	rm -f spectrwm *.o *.so libswmhack.so.* spectrwm.c swm_hack.c tree.h version.h pledge.h

.PHONY: all install clean

=== debian/changelog ===
spectrwm (3.4.1-1) unstable; urgency=medium

  * New upstream release

 -- Andrea Bolognani <eof@kiyuko.org>  Wed, 08 Jul 2020 23:37:22 +0200

spectrwm (3.4.0-1) unstable; urgency=medium

  * New upstream release.

  * Patches
    + Drop linux-Accept-user-provided-pkg-config-command.patch
      - Merged upstream
    + Drop linux-Install-examples.patch
      - Merged upstream
    + Drop Fix-man-warning.patch
      - Merged upstream

 -- Andrea Bolognani <eof@kiyuko.org>  Wed, 24 Jun 2020 22:23:19 +0200

spectrwm (3.3.0-1) unstable; urgency=medium

  * New upstream release.

  * Patches
    + Drop Install-more-files.patch
      - Merged upstream
    + Add linux-Accept-user-provided-pkg-config-command.patch
      - Kindly provided by Helmut Grohne. Along with some changes to
        debian/rules, also suggested by Helmut, this makes it possible
        to successfully cross-build spectrwm.
      - Closes: #928902 (FTCBFS: uses build architecture build tools)
    + Add Fix-man-warning.patch
    + Add linux-Install-examples.patch

  * debhelper
    + Switch to compat level 12

  * Other
    + Update Standards-Version to 4.5.0
      - No changes needed

 -- Andrea Bolognani <eof@kiyuko.org>  Sun, 29 Mar 2020 18:33:58 +0200

=== debian/control ===
Source: spectrwm
Section: x11
Priority: optional
Maintainer: Andrea Bolognani <eof@kiyuko.org>
Build-Depends: debhelper-compat (= 12),
               libx11-dev,
               libx11-xcb-dev,
               libxcursor-dev,
               libxrandr-dev,
               libxt-dev,
               libxtst-dev,
               libxcb1-dev,
               libxcb-icccm4-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev,
               libxcb-util0-dev,
               libxcb-xfixes0-dev,
               libxcb-xinput-dev,
               libxcb-xtest0-dev,
               libxft-dev
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/conformal/spectrwm
Vcs-Git: https://salsa.debian.org/debian/spectrwm.git
Vcs-Browser: https://salsa.debian.org/debian/spectrwm

Package: spectrwm
Architecture: any
Provides: x-window-manager
Depends: suckless-tools,
         xterm | x-terminal-emulator,
         libxt6,
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: xfonts-terminus
Description: dynamic tiling window manager
 spectrwm is a small dynamic tiling window manager for X11.
 .
 It tries to stay out of the way so that valuable screen real estate can
 be used for much more important stuff. It has sane defaults and does not
 require one to learn a language to do any configuration.
 .
 It is written by hackers for hackers and it strives to be small, compact
 and fast.

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
DPKG_EXPORT_BUILDFLAGS=1
include /usr/share/dpkg/buildflags.mk

SOURCEDIR = $(CURDIR)/linux
DESTDIR = $(CURDIR)/debian/tmp

export PREFIX = /usr
export LIBDIR = /usr/lib/spectrwm
export SYSCONFDIR = /etc

%:
	dh $@

# Build, install and clean.
#
# The Makefile we need to use is in the linux/ directory, so we need
# to override the usual dh_auto_* commands to prevent them from using
# the top-level Makefile, which only works on OpenBSD.
#
# We also move some files after installation, to make things easier
# for the tools that are going to move them into the Debian package.
override_dh_auto_build:
	dh_auto_build --sourcedir=$(SOURCEDIR)

override_dh_auto_install:
	dh_auto_install --sourcedir=$(SOURCEDIR) --destdir=$(DESTDIR)
	mv $(DESTDIR)/usr/share/doc/spectrwm/CHANGELOG.md \
	   $(DESTDIR)/usr/share/doc/spectrwm/NEWS

override_dh_auto_clean:
	dh_auto_clean --sourcedir=$(SOURCEDIR)

# Prevent CHANGELOG.md from being installed.
#
# Despite the name, we don't want it to end up being installed as
# changelog.gz, as doing so would go against Policy.
override_dh_installchangelogs:
	dh_installchangelogs --exclude=CHANGELOG.md

# Don't try to run tests.
#
# spectrwm doesn't have a test suite, but the OpenBSD Makefile in the
# top-level directory confuses dh_auto_test's detection and tricks it
# into thinking one exists.
override_dh_auto_test:

# Don't create shlibs files.
#
# libswmhack.so is not a proper shared library, and it should not be
# treated as such.
override_dh_makeshlibs:

=== debian/tests/control ===
Tests: smoke
Depends: spectrwm, xvfb, xfonts-base, x11-utils, wmctrl, procps

## spectrwm 3.5.1

=== linux/Makefile ===
--- 
+++ 
@@ -8,36 +8,36 @@
 XSESSIONSDIR ?= $(DATAROOTDIR)/xsessions
 PKG_CONFIG   ?= pkg-config
 
-BUILDVERSION    = $(shell sh $(CURDIR)/../buildver.sh)
-LIBVERSION      = $(shell .  $(CURDIR)/../lib/shlib_version; echo $$major.$$minor)
-LIBMAJORVERSION = $(shell .  $(CURDIR)/../lib/shlib_version; echo $$major)
+BUILDVERSION    := $(shell sh $(CURDIR)/../buildver.sh)
+LIBVERSION      := $(shell .  $(CURDIR)/../lib/shlib_version; echo $$major.$$minor)
+LIBMAJORVERSION := $(shell .  $(CURDIR)/../lib/shlib_version; echo $$major)
 
-MAINT_CFLAGS   = -std=c99 -Wmissing-prototypes -Wall -Wextra -Wshadow -Wno-uninitialized -g
-MAINT_LDFLAGS  = -Wl,--as-needed
-MAINT_CPPFLAGS = -I. -D_GNU_SOURCE -DSWM_LIB=\"$(LIBDIR)/libswmhack.so.$(LIBVERSION)\"
+MAINT_CFLAGS   := -std=c99 -Wmissing-prototypes -Wall -Wextra -Wshadow -g
+MAINT_LDFLAGS  := -Wl,--as-needed
+MAINT_CPPFLAGS := -I. -D_GNU_SOURCE -DSWM_LIB=\"$(LIBDIR)/libswmhack.so.$(LIBVERSION)\"
 
 ifneq ("${BUILDVERSION}", "")
 MAINT_CPPFLAGS += -DSPECTRWM_BUILDSTR=\"$(BUILDVERSION)\"
 endif
 
-BIN_CFLAGS   = -fPIE
-BIN_LDFLAGS  = -fPIE -pie
-BIN_CPPFLAGS = $(shell $(PKG_CONFIG) --cflags x11 x11-xcb xcb-icccm xcb-keysyms xcb-randr xcb-util xcb-xinput xcb-xtest xcursor xft)
-BIN_LDLIBS   = $(shell $(PKG_CONFIG) --libs   x11 x11-xcb xcb-icccm xcb-keysyms xcb-randr xcb-util xcb-xinput xcb-xtest xcursor xft)
-LIB_CFLAGS   = -fPIC
-LIB_LDFLAGS  = -fPIC -shared
-LIB_CPPFLAGS = $(shell $(PKG_CONFIG) --cflags x11)
-LIB_LDLIBS   = $(shell $(PKG_CONFIG) --libs   x11) -ldl
+BIN_CFLAGS   := -fPIE
+BIN_LDFLAGS  := -fPIE -pie
+BIN_CPPFLAGS := $(shell $(PKG_CONFIG) --cflags x11 x11-xcb xcb-icccm xcb-keysyms xcb-randr xcb-util xcb-xinput xcb-xtest xcursor fontconfig xft)
+BIN_LDLIBS   := $(shell $(PKG_CONFIG) --libs   x11 x11-xcb xcb-icccm xcb-keysyms xcb-randr xcb-util xcb-xinput xcb-xtest xcursor fontconfig xft)
+LIB_CFLAGS   := -fPIC
+LIB_LDFLAGS  := -fPIC -shared
+LIB_CPPFLAGS := $(shell $(PKG_CONFIG) --cflags x11)
+LIB_LDLIBS   := $(shell $(PKG_CONFIG) --libs   x11) -ldl
 
 all: spectrwm libswmhack.so.$(LIBVERSION)
 
 spectrwm: spectrwm.o linux.o
 	$(CC) $(MAINT_LDFLAGS) $(BIN_LDFLAGS) $(LDFLAGS) -o $@ $+ $(BIN_LDLIBS) $(LDLIBS)
 
-spectrwm.o: ../spectrwm.c ../version.h tree.h util.h
+spectrwm.o: ../spectrwm.c ../version.h tree.h util.h queue_compat.h
 	$(CC) $(MAINT_CFLAGS) $(BIN_CFLAGS) $(CFLAGS) $(MAINT_CPPFLAGS) $(BIN_CPPFLAGS) $(CPPFLAGS) -c -o $@ $<
 
-linux.o: linux.c util.h
+linux.o: linux.c util.h queue_compat.h
 	$(CC) $(MAINT_CFLAGS) $(BIN_CFLAGS) $(CFLAGS) $(MAINT_CPPFLAGS) $(BIN_CPPFLAGS) $(CPPFLAGS) -c -o $@ $<
 
 libswmhack.so.$(LIBVERSION): swm_hack.so

=== debian/changelog ===
spectrwm (3.5.1-1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:21:16 +1100

spectrwm (3.5.1-1ubuntu1) noble; urgency=medium

  * Don't hard-code dependency on on shared library package.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Mar 2024 17:42:09 +0100

spectrwm (3.5.1-1build1) noble; urgency=medium

  * No-change rebuild against libxt6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Mar 2024 00:54:57 +0000

spectrwm (3.5.1-1) unstable; urgency=medium

  * New upstream release

  * Patches
    + Drop backports
    + Update debian/Change-default-programs.patch
      - Reflect Debian-specific default programs in
        /etc/spectrwm.conf too

  * Package relationships
    + Add Build-Depends on libfontconfig-dev
      - New dependency introduced upstream
    + Drop Build-Depends on libxtst-dev and libxcb-xfixes0-dev
      - No longer needed

 -- Andrea Bolognani <eof@kiyuko.org>  Sun, 07 Jan 2024 17:50:24 +0100

spectrwm (3.4.1-3) unstable; urgency=medium

  * Patches
    + Convert accepted forwarded patch to backport
    + Fix tagging of Debian-specific patch

 -- Andrea Bolognani <eof@kiyuko.org>  Sun, 12 Feb 2023 16:55:17 +0100

spectrwm (3.4.1-2) unstable; urgency=medium

  * Patches
    + Reorganize by using gbp pq's topic feature
    + Add forward/Escape-backslashes-correctly-in-manual-page.patch
      - Fixes acute-accent-in-manual-page Lintian tag

  * Package relationships
    + Build-Depend on libxcb-util-dev instead of libxcb-util0-dev
      - Fixes build-depends-on-obsolete-package Lintian tag

  * debhelper
    + Switch to compat level 13
      - Contributed by Debian Janitor

  * Standards-Version
    + Update to 4.6.2
      - Set priority to 40 for the x-window-manager alternative

  * Other
    + Fix watch file
      - Adapt to recent changes in GitHub

 -- Andrea Bolognani <eof@kiyuko.org>  Mon, 06 Feb 2023 22:28:49 +0100

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,25 @@
 Source: spectrwm
 Section: x11
 Priority: optional
-Maintainer: Andrea Bolognani <eof@kiyuko.org>
-Build-Depends: debhelper-compat (= 12),
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrea Bolognani <eof@kiyuko.org>
+Build-Depends: debhelper-compat (= 13),
                libx11-dev,
                libx11-xcb-dev,
                libxcursor-dev,
                libxrandr-dev,
                libxt-dev,
-               libxtst-dev,
                libxcb1-dev,
                libxcb-icccm4-dev,
                libxcb-keysyms1-dev,
                libxcb-randr0-dev,
-               libxcb-util0-dev,
-               libxcb-xfixes0-dev,
+               libxcb-util-dev,
                libxcb-xinput-dev,
                libxcb-xtest0-dev,
+               libfontconfig-dev,
                libxft-dev
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/conformal/spectrwm
 Vcs-Git: https://salsa.debian.org/debian/spectrwm.git
 Vcs-Browser: https://salsa.debian.org/debian/spectrwm
@@ -29,7 +29,7 @@
 Provides: x-window-manager
 Depends: suckless-tools,
          xterm | x-terminal-emulator,
-         libxt6,
+         ${lib:Depends},
          ${shlibs:Depends},
          ${misc:Depends}
 Recommends: xfonts-terminus

=== debian/rules ===
--- 
+++ 
@@ -52,3 +52,16 @@
 # libswmhack.so is not a proper shared library, and it should not be
 # treated as such.
 override_dh_makeshlibs:
+
+# Set priority for the x-window-manager alternative.
+#
+# According to Policy, the base priority is 40. It can then be
+# increased based on additional features that the window manager
+# implements, but spectrwm doesn't qualify for any of those bonuses.
+override_dh_installwm:
+	dh_installwm --priority=40
+
+override_dh_gencontrol:
+	dh_gencontrol -- \
+	  -Vlib:Depends=$(shell dpkg-query -W -f '$${Depends}' libxt-dev \
+			| sed -E 's/.*(libxt[[:alnum:].-]+).*/\1/')

## spectrwm 3.6.0

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 # Uncomment define below to disallow user settable clock format string
 #CFLAGS+=-DSWM_DENY_CLOCK_FORMAT
 CPPFLAGS+= -I${X11BASE}/include -I${X11BASE}/include/freetype2
-LDADD+=-lutil -L${X11BASE}/lib -lX11 -lX11-xcb -lxcb -lxcb-util -lxcb-icccm -lxcb-keysyms -lxcb-randr -lxcb-xinput -lxcb-xtest -lXft -lXcursor
+LDADD+=-lutil -L${X11BASE}/lib -lX11 -lX11-xcb -lxcb -lxcb-util -lxcb-icccm -lxcb-keysyms -lxcb-randr -lxcb-xinput -lxcb-xtest -lfontconfig -lXft -lXcursor
 BUILDVERSION != sh "${.CURDIR}/buildver.sh"
 .if !${BUILDVERSION} == ""
 CPPFLAGS+= -DSPECTRWM_BUILDSTR=\"$(BUILDVERSION)\"

=== debian/changelog ===
spectrwm (3.6.0-1) unstable; urgency=medium

  * New upstream release

  * Package relationships
    + Add Build-Depends on libbsd-dev
      - libbsd is now used instead of vendored BSD code
    + Drop Build-Depends on libxrandr-dev
      - No longer used

 -- Andrea Bolognani <eof@kiyuko.org>  Fri, 02 Aug 2024 23:34:16 +0200

spectrwm (3.5.1-2) unstable; urgency=medium

  * Interoperability
    + Integrate with xdg-desktop-portal
      - The GTK portal will be used by default
      - Closes: #1051018 (spectrwm: please set XDG_CURRENT_DESKTOP
        and use it to configure xdg-desktop-portal)

  * Package relationships
    + Drop Depends on libxt6
      - We don't link to it directly, and libswmhack only tries
        to load it when running an application that already links
        against (and thus by definition Depends on) the library
      - In addition to being unnecessary, the hardcoded dependency
        was getting in the way of the 64-bit time_t transition
      - Closes: #1068203 (spectrwm: hard-coded dependency on
        pre-t64 library)

  * Standards-Version
    + Update to 4.7.0
      - No changes needed

 -- Andrea Bolognani <eof@kiyuko.org>  Sun, 21 Apr 2024 12:43:55 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: spectrwm
 Section: x11
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andrea Bolognani <eof@kiyuko.org>
+Maintainer: Andrea Bolognani <eof@kiyuko.org>
 Build-Depends: debhelper-compat (= 13),
+               libbsd-dev,
                libx11-dev,
                libx11-xcb-dev,
                libxcursor-dev,
-               libxrandr-dev,
                libxt-dev,
                libxcb1-dev,
                libxcb-icccm4-dev,
@@ -19,7 +18,7 @@
                libfontconfig-dev,
                libxft-dev
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/conformal/spectrwm
 Vcs-Git: https://salsa.debian.org/debian/spectrwm.git
 Vcs-Browser: https://salsa.debian.org/debian/spectrwm
@@ -29,7 +28,6 @@
 Provides: x-window-manager
 Depends: suckless-tools,
          xterm | x-terminal-emulator,
-         ${lib:Depends},
          ${shlibs:Depends},
          ${misc:Depends}
 Recommends: xfonts-terminus

## spectrwm 3.7.0

=== freebsd/Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 CFLAGS+= -I. -I${LOCALBASE}/include -I${LOCALBASE}/include/freetype2
 CFLAGS+= -DSWM_LIB=\"$(SWM_LIBDIR)/libswmhack.so.$(LVERS)\"
 LDADD+= -lutil -L${LOCALBASE}/lib -lX11 -lX11-xcb -lxcb \
-	-lxcb-icccm -lxcb-keysyms -lxcb-randr -lxcb-util -lxcb-xinput -lxcb-xtest -lXft -lXcursor
+	-lxcb-icccm -lxcb-keysyms -lxcb-randr -lxcb-util -lxcb-xinput -lxcb-xtest -lfontconfig -lXft -lXcursor
 
 
 all: spectrwm libswmhack.so.$(LVERS)
@@ -27,7 +27,7 @@
 spectrwm.c:
 	ln -sf ../spectrwm.c
 	ln -sf ../version.h
-	ln -sf ../linux/pledge.h
+	ln -sf ../linux/queue_compat.h
 
 swm_hack.c:
 	ln -sf ../lib/swm_hack.c
@@ -51,7 +51,7 @@
 	ln -sf spectrwm $(SWM_BINDIR)/scrotwm
 
 clean:
-	rm -f spectrwm *.o *.so libswmhack.so.* spectrwm.c swm_hack.c version.h pledge.h
+	rm -f spectrwm *.o *.so libswmhack.so.* spectrwm.c swm_hack.c version.h queue_compat.h
 
 .PHONY:	all install clean

=== linux/Makefile ===
--- 
+++ 
@@ -22,22 +22,19 @@
 
 BIN_CFLAGS   := -fPIE
 BIN_LDFLAGS  := -fPIE -pie
-BIN_CPPFLAGS := $(shell $(PKG_CONFIG) --cflags x11 x11-xcb xcb-icccm xcb-keysyms xcb-randr xcb-util xcb-xinput xcb-xtest xcursor fontconfig xft)
-BIN_LDLIBS   := $(shell $(PKG_CONFIG) --libs   x11 x11-xcb xcb-icccm xcb-keysyms xcb-randr xcb-util xcb-xinput xcb-xtest xcursor fontconfig xft)
+BIN_CPPFLAGS := $(shell $(PKG_CONFIG) --cflags libbsd-overlay x11 x11-xcb xcb-icccm xcb-keysyms xcb-randr xcb-util xcb-xinput xcb-xtest xcursor fontconfig xft)
+BIN_LDLIBS   := $(shell $(PKG_CONFIG) --libs   libbsd-overlay x11 x11-xcb xcb-icccm xcb-keysyms xcb-randr xcb-util xcb-xinput xcb-xtest xcursor fontconfig xft)
 LIB_CFLAGS   := -fPIC
 LIB_LDFLAGS  := -fPIC -shared
 LIB_CPPFLAGS := $(shell $(PKG_CONFIG) --cflags x11)
-LIB_LDLIBS   := $(shell $(PKG_CONFIG) --libs   x11) -ldl
+LIB_LDLIBS   := -ldl
 
 all: spectrwm libswmhack.so.$(LIBVERSION)
 
-spectrwm: spectrwm.o linux.o
+spectrwm: spectrwm.o
 	$(CC) $(MAINT_LDFLAGS) $(BIN_LDFLAGS) $(LDFLAGS) -o $@ $+ $(BIN_LDLIBS) $(LDLIBS)
 
 spectrwm.o: ../spectrwm.c ../version.h tree.h util.h queue_compat.h
-	$(CC) $(MAINT_CFLAGS) $(BIN_CFLAGS) $(CFLAGS) $(MAINT_CPPFLAGS) $(BIN_CPPFLAGS) $(CPPFLAGS) -c -o $@ $<
-
-linux.o: linux.c util.h queue_compat.h
 	$(CC) $(MAINT_CFLAGS) $(BIN_CFLAGS) $(CFLAGS) $(MAINT_CPPFLAGS) $(BIN_CPPFLAGS) $(CPPFLAGS) -c -o $@ $<
 
 libswmhack.so.$(LIBVERSION): swm_hack.so
@@ -70,7 +67,7 @@
 	install -m 644 ../initscreen.sh            $(DESTDIR)$(DOCDIR)/examples
 	install -m 644 ../screenshot.sh            $(DESTDIR)$(DOCDIR)/examples
 	install -m 644 ../spectrwm_*.conf          $(DESTDIR)$(DOCDIR)/examples
-	install -m 644 spectrwm.desktop            $(DESTDIR)$(XSESSIONSDIR)
+	install -m 644 ../spectrwm.desktop         $(DESTDIR)$(XSESSIONSDIR)
 
 uninstall:
 	rm -f $(DESTDIR)$(BINDIR)/spectrwm

=== netbsd/Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 CFLAGS+= -I. -I${LOCALBASE}/include -I${LOCALBASE}/include/freetype2
 CFLAGS+= -DSWM_LIB=\"$(SWM_LIBDIR)/libswmhack.so.$(LVERS)\"
 LDADD+= -lutil -L${LOCALBASE}/lib -lX11 -lX11-xcb -lxcb \
-	-lxcb-icccm -lxcb-keysyms -lxcb-randr -lxcb-util -lxcb-xinput -lxcb-xtest -lXft -lXcursor
+	-lxcb-icccm -lxcb-keysyms -lxcb-randr -lxcb-util -lxcb-xinput -lxcb-xtest -lfontconfig -lXft -lXcursor
 
 
 all: spectrwm libswmhack.so.$(LVERS)
@@ -25,7 +25,7 @@
 spectrwm.c:
 	ln -sf ../spectrwm.c
 	ln -sf ../version.h
-	ln -sf ../linux/pledge.h
+	ln -sf ../linux/queue_compat.h
 
 swm_hack.c:
 	ln -sf ../lib/swm_hack.c
@@ -49,7 +49,7 @@
 	ln -sf spectrwm $(SWM_BINDIR)/scrotwm
 
 clean:
-	rm -f spectrwm *.o *.so libswmhack.so.* spectrwm.c swm_hack.c version.h
+	rm -f spectrwm *.o *.so libswmhack.so.* spectrwm.c swm_hack.c version.h queue_compat.h
 
 .PHONY:	all install clean

=== osx/Makefile ===
--- 
+++ 
@@ -7,16 +7,16 @@
 
 # To use xquartz, uncomment the following three lines.
 INCFLAGS+= -I/opt/X11/include -I/opt/X11/include/freetype2/
-LDADD+=  -L/opt/X11/lib -lX11 -lXcursor -lXft
+LDADD+=  -L/opt/X11/lib -lX11 -lXcursor -lfontconfig -lXft
 
 # To use homebrew, uncomment the following three lines.
 #INCFLAGS+= -I/opt/X11/include
-#LDADD+=  -lX11 -lXcursor -lXft -L/opt/X11/lib
+#LDADD+=  -lX11 -lXcursor -lfontconfig -lXft -L/opt/X11/lib
 #INCFLAGS+= -I/usr/local/Cellar/freetype/2.5.0.1/include/freetype2
 
 # To use homebrew , comment out the following two lines.
 #INCFLAGS+= -I/opt/local/include/freetype2 -I/opt/local/include
-#LDADD+=  -L/opt/local/lib -lX11 -lXcursor -lXft
+#LDADD+=  -L/opt/local/lib -lX11 -lXcursor -lfontconfig -lXft
 
 LDADD+=  -lxcb-keysyms -lxcb-util -lxcb-randr -lX11-xcb -lxcb-xtest -lxcb -lxcb-icccm
 
@@ -37,7 +37,7 @@
 	ln -sf ../linux/tree.h
 	ln -sf ../spectrwm.c
 	ln -sf ../version.h
-	ln -sf ../linux/pledge.h
+	ln -sf ../linux/queue_compat.h
 
 swm_hack.c:
 	ln -sf ../lib/swm_hack.c
@@ -65,6 +65,6 @@
 	ln -sf libswmhack.so.0.0 $(DESTDIR)$(LIBDIR)/libswmhack.so
 
 clean:
-	rm -f spectrwm *.o *.so libswmhack.so.* spectrwm.c swm_hack.c tree.h version.h pledge.h
+	rm -f spectrwm *.o *.so libswmhack.so.* spectrwm.c swm_hack.c tree.h version.h queue_compat.h
 
 .PHONY: all install clean

=== debian/changelog ===
spectrwm (3.7.0-1) unstable; urgency=medium

  * New upstream release

  * Standards-Version
    + Update to 4.7.2
      - No changes needed

 -- Andrea Bolognani <eof@kiyuko.org>  Mon, 13 Oct 2025 22:47:57 +0200

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                libfontconfig-dev,
                libxft-dev
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/conformal/spectrwm
 Vcs-Git: https://salsa.debian.org/debian/spectrwm.git
 Vcs-Browser: https://salsa.debian.org/debian/spectrwm

=== debian/rules ===
--- 
+++ 
@@ -29,6 +29,9 @@
 	dh_auto_install --sourcedir=$(SOURCEDIR) --destdir=$(DESTDIR)
 	mv $(DESTDIR)/usr/share/doc/spectrwm/CHANGELOG.md \
 	   $(DESTDIR)/usr/share/doc/spectrwm/NEWS
+	mkdir -p $(DESTDIR)/usr/share/xdg-desktop-portal/
+	cp debian/spectrwm-portals.conf \
+	   $(DESTDIR)/usr/share/xdg-desktop-portal/
 
 override_dh_auto_clean:
 	dh_auto_clean --sourcedir=$(SOURCEDIR)
@@ -60,8 +63,3 @@
 # implements, but spectrwm doesn't qualify for any of those bonuses.
 override_dh_installwm:
 	dh_installwm --priority=40
-
-override_dh_gencontrol:
-	dh_gencontrol -- \
-	  -Vlib:Depends=$(shell dpkg-query -W -f '$${Depends}' libxt-dev \
-			| sed -E 's/.*(libxt[[:alnum:].-]+).*/\1/')

=== debian/watch ===
version=4
opts=\
pgpmode=none,\
searchmode=plain,\
downloadurlmangle=s%^.+/([^/]+)$%https://github.com/conformal/spectrwm/archive/refs/tags/$1.tar.gz%,\
filenamemangle=s%^.+_(\d+)_(\d+)_(\d+)$%spectrwm-$1.$2.$3.tar.gz% \
\
https://api.github.com/repos/conformal/spectrwm/releases \
https://api.github.com/repos/conformal/spectrwm/tarball/SPECTRWM_(\d+)_(\d+)_(\d+)
